diff --git a/tests/drmstat.c b/tests/drmstat.c
index 0ed5caf..c800ebb 100644
--- a/tests/drmstat.c
+++ b/tests/drmstat.c
@@ -82,7 +82,7 @@ static void getversion(int fd)
     }
 }
 
-void process_sigio(char *device)
+static void process_sigio(char *device)
 {
     int              fd;
 
diff --git a/tests/kmstest/main.c b/tests/kmstest/main.c
index 59e6113..1d4c63e 100644
--- a/tests/kmstest/main.c
+++ b/tests/kmstest/main.c
@@ -37,7 +37,7 @@
 		return ret; \
 	}
 
-int test_bo(struct kms_driver *kms)
+static int test_bo(struct kms_driver *kms)
 {
 	struct kms_bo *bo;
 	int ret;
diff --git a/tests/modeprint/modeprint.c b/tests/modeprint/modeprint.c
index 2d998d5..508c9f2 100644
--- a/tests/modeprint/modeprint.c
+++ b/tests/modeprint/modeprint.c
@@ -53,7 +53,7 @@ int crtcs;
 int fbs;
 char *module_name;
 
-const char* getConnectionText(drmModeConnection conn)
+static const char* getConnectionText(drmModeConnection conn)
 {
 	switch (conn) {
 	case DRM_MODE_CONNECTED:
@@ -67,7 +67,7 @@ const char* getConnectionText(drmModeConnection conn)
 
 }
 
-int printMode(struct drm_mode_modeinfo *mode)
+static int printMode(struct drm_mode_modeinfo *mode)
 {
 	if (full_modes) {
 		printf("Mode: %s\n", mode->name);
@@ -91,7 +91,7 @@ int printMode(struct drm_mode_modeinfo *mode)
 	return 0;
 }
 
-int printProperty(int fd, drmModeResPtr res, drmModePropertyPtr props, uint64_t value)
+static int printProperty(int fd, drmModeResPtr res, drmModePropertyPtr props, uint64_t value)
 {
 	const char *name = NULL;
 	int j;
@@ -162,7 +162,7 @@ static const char * const output_names[] = { "None",
 					     "DSI",
 };
 
-int printConnector(int fd, drmModeResPtr res, drmModeConnectorPtr connector, uint32_t id)
+static int printConnector(int fd, drmModeResPtr res, drmModeConnectorPtr connector, uint32_t id)
 {
 	int i = 0;
 	struct drm_mode_modeinfo *mode = NULL;
@@ -215,7 +215,7 @@ int printConnector(int fd, drmModeResPtr res, drmModeConnectorPtr connector, uin
 	return 0;
 }
 
-int printEncoder(int fd, drmModeResPtr res, drmModeEncoderPtr encoder, uint32_t id)
+static int printEncoder(int fd, drmModeResPtr res, drmModeEncoderPtr encoder, uint32_t id)
 {
 	printf("Encoder\n");
 	printf("\tid     :%i\n", id);
@@ -226,7 +226,7 @@ int printEncoder(int fd, drmModeResPtr res, drmModeEncoderPtr encoder, uint32_t
 	return 0;
 }
 
-int printCrtc(int fd, drmModeResPtr res, drmModeCrtcPtr crtc, uint32_t id)
+static int printCrtc(int fd, drmModeResPtr res, drmModeCrtcPtr crtc, uint32_t id)
 {
 	printf("Crtc\n");
 	printf("\tid             : %i\n", id);
@@ -240,7 +240,7 @@ int printCrtc(int fd, drmModeResPtr res, drmModeCrtcPtr crtc, uint32_t id)
 	return 0;
 }
 
-int printFrameBuffer(int fd, drmModeResPtr res, drmModeFBPtr fb)
+static int printFrameBuffer(int fd, drmModeResPtr res, drmModeFBPtr fb)
 {
 	printf("Framebuffer\n");
 	printf("\thandle    : %i\n", fb->handle);
@@ -254,7 +254,7 @@ int printFrameBuffer(int fd, drmModeResPtr res, drmModeFBPtr fb)
 	return 0;
 }
 
-int printRes(int fd, drmModeResPtr res)
+static int printRes(int fd, drmModeResPtr res)
 {
 	int i;
 	drmModeFBPtr fb;
@@ -330,7 +330,7 @@ int printRes(int fd, drmModeResPtr res)
 	return 0;
 }
 
-void args(int argc, char **argv)
+static void args(int argc, char **argv)
 {
 	int i;
 
diff --git a/tests/proptest/proptest.c b/tests/proptest/proptest.c
index 4b7234d..9b2eb3f 100644
--- a/tests/proptest/proptest.c
+++ b/tests/proptest/proptest.c
@@ -44,7 +44,7 @@ static inline int64_t U642I64(uint64_t val)
 int fd;
 drmModeResPtr res = NULL;
 
-const char *connector_type_str(uint32_t type)
+static const char *connector_type_str(uint32_t type)
 {
 	switch (type) {
 	case DRM_MODE_CONNECTOR_Unknown:
diff --git a/tests/radeon/radeon_ttm.c b/tests/radeon/radeon_ttm.c
index ac3297a..8346e85 100644
--- a/tests/radeon/radeon_ttm.c
+++ b/tests/radeon/radeon_ttm.c
@@ -32,7 +32,7 @@
 /* allocate as many single page bo to try to starve the kernel
  * memory zone (below highmem)
  */
-void ttm_starve_kernel_private_memory(int fd)
+static void ttm_starve_kernel_private_memory(int fd)
 {
     struct list_head list;
     struct rbo *bo, *tmp;
@@ -55,7 +55,7 @@ void ttm_starve_kernel_private_memory(int fd)
     }
 }
 
-int radeon_open_fd(void)
+static int radeon_open_fd(void)
 {
     return drmOpen("radeon", NULL);
 }